<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

session_start();
if(!isset($_SESSION['id']))exit;
if(!isset($_SESSION['ADMIN_USER']))exit;

define('ALUMNISERVER',true);
include('loadminconfig.php');
include('../admin/admin_update_functions.php');

$new_structure=getDbStructureFromFile('../db_alumni.sql');
$existing_structure=getDbStructure();
$existing_structure=str_replace('  ',' ',$existing_structure);
$extra_diff=getExtraDiff($new_structure,$existing_structure);
$update_statements=getUpdateQueries($extra_diff);

$out='<h3>Comparison between existing and new database structure:</h3>
<div style="width:580px;height:300px;overflow:scroll;background-color:#f7f7f7;padding:8px;">';

$green='#386d38';
$red='#ae6565';
foreach(array_keys($new_structure) as $table){
	$out.= '<table style="width:560px;background-color:#d0d0d0;margin-bottom:20px;" cellspacing="1">';

	if(!key_exists($table,$existing_structure)){
		$out.='<tr><td colspan="2" style="background-color:#fff;color:'.$green.'">'.$table.'</td></tr>';
	}
	else{
		$out.='<tr><td colspan="2" style="background-color:#fff;">'.$table.'</td></tr>';
	}

	foreach(array_keys($new_structure[$table]['fields']) as $masterFieldName){
		$slaveFieldName='';
		$slaveFieldContent='';
		if(key_exists($table,$existing_structure)){
			if(key_exists('fields',$existing_structure[$table])){
				if(key_exists($masterFieldName,$existing_structure[$table]['fields'])){
					$slaveFieldName=$masterFieldName;
					$slaveFieldContent=$existing_structure[$table]['fields'][$masterFieldName];
				}
			}
		}
		$masterFieldContent=$new_structure[$table]['fields'][$masterFieldName];

		// compare field name
		$out.='<tr>';
		if($masterFieldName!=$slaveFieldName&&$slaveFieldName!=''){
			$out.='<td style="background-color:#f7f7f7;">
					<div style="color:'.$red.';text-decoration:line-through;">'.$slaveFieldName.'</div>
					<div style="color:'.$green.';">'.$masterFieldName.'</div>
				</td>';
		}
		else{
			$out.='<td style="background-color:#f7f7f7;">
					<div style="color:#999;">'.$masterFieldName.'</div>
				</td>';
		}

		// compare field type etc
		if($masterFieldContent!=$slaveFieldContent&&$slaveFieldContent!=''){
			if(strstr($masterFieldContent,'  ')){
				echo 'warning: double space in $masterFieldContent<br/>';
			}
			if(strstr($slaveFieldContent,'  ')){
				echo 'warning: double space in $slaveFieldContent<br/>';
			}

			$out.= '
			<td style="background-color:#f7f7f7;">
				<div style="color:'.$red.';text-decoration:line-through;">'.$slaveFieldContent.'</div>
				<div style="color:'.$green.';">'.$masterFieldContent.'</td>
			</td>';
		}
		else{
			$out.='<td style="background-color:#f7f7f7;">
					<div style="color:#999;">'.$masterFieldContent.'</div>
				</td>';
		}
		$out.='</tr>';
	}

	// keys:
	$out.='<tr><td colspan="2" style="background-color:#f7f7f7;">';
	if(is_array($new_structure[$table]['keys'])){
		foreach(array_keys($new_structure[$table]['keys']) as $key){
			$new_key=$new_structure[$table]['keys'][$key];
			$existing_key='';
			if(key_exists($table,$existing_structure)){
				if(key_exists('keys',$existing_structure[$table])){
					if(key_exists($key,$existing_structure[$table]['keys'])){
						$existing_key=$existing_structure[$table]['keys'][$key];
					}
				}
			}

			if($new_key!=$existing_key&&$existing_key!=''){
				$out.='<div style="color:'.$red.';text-decoration:line-through;">'.$key.': '.$existing_key.'</div>
				<div style="color:'.$green.';">'.$key.': '.$new_key.'</div>';
			}
			else{
				$out.= '<div style="color:#999;">'.$key.': '.$new_key.'</div>';
			}
		}
	}
	$out.= '</td></tr>';

	// extra of the table:
	$out.=  '<tr><td colspan="2" style="background-color:#f7f7f7;">';

	if(is_array($new_structure[$table]['extra'])){
		foreach(array_keys($new_structure[$table]['extra']) as $key){

			$new_extra=$new_structure[$table]['extra'][$key];
			$existing_extra='';
			if(key_exists($table,$existing_structure)){
				if(key_exists('extra',$existing_structure[$table])){
					if(key_exists($key,$existing_structure[$table]['extra'])){
						$existing_extra=$existing_structure[$table]['extra'][$key];
					}
				}
			}

			if($new_extra!=$existing_extra&&$existing_extra!=''){
				$out.='<div style="color:'.$red.';text-decoration:line-through;">'.$key.': '.$existing_extra.'</div>
				<div style="color:'.$green.';">'.$key.': '.$new_extra.'</div>';
			}
			else{
				$out.= '<div style="color:#999;">'.$key.': '.$new_extra.'</div>';
			}
		}
	}
	$out.= '</td></tr>';
	$out.= '</table>';
}

$out.= '</div>';
echo $out;
mysql_close($dbh);
?>
