<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

session_start();
if(!isset($_SESSION['id'])){die('no session');}
define('ALUMNISERVER',true);
include('loadminconfig.php');
include('../common.php');

// show details
function fs_show_detail($detail){
	global $out;
	if(isset($_POST['show_'.$detail])){

		$show=requestVar('show_'.$detail,'');
		if(intval($show)==1){
			$_SESSION['fs']['show_'.$detail]=1;
		}
		else{
			$_SESSION['fs']['show_'.$detail]=0;
		}
	}
}
fs_show_detail('city');
fs_show_detail('zipcode');
fs_show_detail('employer');
fs_show_detail('placeofwork');
fs_show_detail('graduation');

// order
$orderby='';
if(isset($_POST['orderby'])){
	$orderby=requestVar('orderby','');
	if(!preg_match('/^[a-z]{2,20}$/',$orderby))exit;
	$_SESSION['fs']['orderby']=$orderby;
}
else if(isset($_SESSION['orderby'])){
	$orderby=$_SESSION['fs']['orderby'];
}

// search string
$search='';
if(isset($_SESSION['fs']['search'])){
	$search=$_SESSION['fs']['search'];
}

$uid=$_SESSION['id'];

// skim
$num_profiles_per_page=20;
$page=1;
if(isset($_POST['page'])){
	$page=requestVar('page',1);
}
if($page<0)exit;
$limit=($page-1)*$num_profiles_per_page;
$pageLink='?page='.$page;

$tables=array('gn','sn','city','zipcode','employer','placeofwork','graduation');
$sql_order='ORDER BY `sn`';
if(in_array($orderby,$tables)){
	$sql_order="ORDER BY IF(ISNULL(`$orderby`) OR `$orderby` LIKE '',1,0),`$orderby` ";
}

$sql_count="SELECT COUNT(*) FROM `as_users` WHERE `hideuser` LIKE 'n'";
$sql_select="SELECT * FROM `as_users` WHERE `hideuser` LIKE 'n' $sql_order LIMIT $limit, $num_profiles_per_page";

if(strlen($search)>0){
	$search=mysql_real_escape_string($search,$dbh);

	$search_in['gn']=$tr['Gn'];
	$search_in['sn']=$tr['Sn'];
	$search_in['city']=$tr['PlaceOfResidence'];
	$search_in['zipcode']=$tr['Zipcode'];
	$search_in['employer']=$tr['Employer'];
	$search_in['placeofwork']=$tr['PlaceOfWork'];
	$search_in['graduation']=$tr['YearOfGraduation'];

	$first=true;
	$num_tables=0;
	$sql_and='';

	foreach($search_in as $search_key=>$search_label){
		if(isset($_SESSION['fs']['search_'.$search_key])){
			if($_SESSION['fs']['search_'.$search_key]==1){
				++$num_tables;
				if($first){
					$sql_and.=" (`as_users`.`$search_key` LIKE '%$search%')";
					$first=false;
				}
				else{
					$sql_and.=" OR (`as_users`.`$search_key` LIKE '%$search%')";
				}
			}
		}
	}

	if($num_tables>0){
		$sql_and='WHERE ('.$sql_and.')';
	}
	else{
		$sql_and='';
	}

	$sql_count="SELECT COUNT(*) FROM `as_users` $sql_and";
	//$sql_select="SELECT * FROM `as_users` WHERE `hideuser` LIKE 'n' $sql_and $sql_order LIMIT $limit, $num_profiles_per_page";
	$sql_select="SELECT * FROM `as_users` $sql_and $sql_order LIMIT $limit, $num_profiles_per_page";
}

$r_count=mysql_query($sql_count,$dbh);
$r_select=mysql_query($sql_select,$dbh);

if($r_select){
	if(mysql_num_rows($r_select)==0){
		echo '<div style="float:left;margin-top:6px;"><b>'.$tr['NoFellowStudentsToThisSearchFound'].'</b></div>';
		return;
	}
}

$a_count=mysql_fetch_row($r_count);
$num_users=$a_count[0];

function skimjs($page,$numpages,$float='left'){
	$skim='<ul class="skim" style="float:'.$float.';padding:0px;margin-top:3px;margin-bottom:3px;">';
	$b1=$page-1;
	$b2=$page-2;
	$b3=$page-3;
	$b4=$page-4;
	$n1=$page+1;
	$n2=$page+2;
	$n3=$page+3;
	$n4=$page+4;

	for($i=1;$i<=$numpages;++$i){
		$style='';
		if($i==$page){
			$style='style="font-weight:bold;background-color:#edf3f3;border:#dde3e3 1px solid;padding:2px 4px;"';
		}

		if( ($i==1 ) || ($i==$numpages ) ){
		}
		else if( ($i==$b4 && $b4>2 ) || ($i==$n4 && $n4<$numpages-1 ) ){
			$skim.='<li><div style="padding:2px 4px;width:14px;height:17px;">...</div></li>';
			continue;
		}
		else if( ($i==$b4 && $b4==2 ) || ($i==$n4 && $n4==$numpages-1 ) ){
		}
		else if( ($i<$b4 && $b4>2 ) || ($i>$n4 && $n4<$numpages-1 ) ){
			continue;
		}
		$skim.='<li><a href="javascript:void(0);" onclick="fs_page('.$i.');" '.$style.'>'.$i.'</a></li>';
	}
	$skim.='</ul>';
	return $skim;
}

$out='<div style="width:600px;">';
$num_pages=ceil($num_users/$num_profiles_per_page);
if($num_pages>1){
	$out.=skimjs($page,$num_pages,'left');
}

$orderoption['gn']=$tr['Gn'];
$orderoption['sn']=$tr['Sn'];
$orderoption['city']=$tr['PlaceOfResidence'];
$orderoption['zipcode']=$tr['Zipcode'];
$orderoption['employer']=$tr['Employer'];
$orderoption['placeofwork']=$tr['PlaceOfWork'];
$orderoption['graduation']=$tr['YearOfGraduation'];

$out.='<div style="float:right;margin-top:5px;vertical-align:sub;" id="fsloading">'.$tr['OrderBy'].'
<select style="color:#555555;font-size:11px;margin:0px;padding:0px;" id="orderby" name="orderby" onchange="fs_order_by(this)">';

foreach($orderoption as $orderkey=>$orderlabel){
	$selected='';
	if($_SESSION['fs']['orderby']==$orderkey){
		$selected=' selected';
	}
	$out.='<option value="'.$orderkey.'"'.$selected.'>'.$orderlabel.'</option>';
}
$out.='</select></div></div>';

while($a=mysql_fetch_array($r_select)){
	$photo='data/images/profile/'.$a['photo'].'t.jpg';
	if(strlen($a['photo'])<6){
		$photo='src/img/nopicmt.jpg';
		if($a['sex']=='female')$photo='src/img/nopicft.jpg';
	}

	$out.='<div id="'.$a['id'].'" style="float:left;clear:both;">
	<a class="fs" href="javascript:void(0);" onclick="fs_load_profile(\''.$a['id'].'\')">
	<div style="float:left;width:72px;"><img src="'.$photo.'" border="0" alt=""></div>

	<div style="width:200px;float:left;">
	<span style="font-weight:bold;">'.$a['gn'].' '.$a['sn'].'</span><br/>';

	if($_SESSION['fs']['show_city']==1){
		if(strlen($a['zipcode'])>0||strlen($a['city'])>0){
			$out.=$a['zipcode'].' '.$a['city'].'<br/>';
		}
	}
	if($_SESSION['fs']['show_graduation']==1){
		if(strlen($a['graduation'])>0){
			$out.=$tr['YearOfGraduation'].': '.$a['graduation'];
		}
	}

	$out.='</div><div style="width:300px;float:left;">';
	if($_SESSION['fs']['show_employer']==1){
		if(strlen($a['employer'])>0){
			$out.=$tr['Employer'].': '.$a['employer'].'<br/>';
		}
	}
	if($_SESSION['fs']['show_placeofwork']==1){
		if(strlen($a['placeofwork'])>0){
			$out.=$tr['PlaceOfWork'].': '.$a['placeofwork'].'<br/>';
		}
	}

	$out.='</div></a></div><div style="height:3px;width:1px;float:left;clear:both;"></div>';
}
echo $out;
?>