<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

if(!defined('ALUMNISERVER'))exit;
if(!isset($_SESSION['ADMIN_USER']))exit;

function saveUploadLogo(){
	global $tr;
	if(!$_FILES['logoupload']['tmp_name']){
		$_SESSION['ADMIN_HINT']='<div style="color:red;">Upload failed. Please try again.</div>';
		return;
	}

	if($_FILES['logoupload']['size']>524*1024){
		$size=$_FILES['photoupload']['size']/1024;
		$size=round($size,1);
		echo $tr['FileIsTooBig'].'.<br/>'.$tr['SizeOfUploadedFile'].': '.$size.' kByte<br/>'.$tr['MaximumFileSize'].': 500 kByte';
		return;
	}

	if($_FILES['logoupload']['type']!='image/gif'){
		$_SESSION['ADMIN_HINT']='<div style="color:red;">Only gif images can be uploaded as logo</div>';
		return;
	}
	$uploadpath='data/AlumniLogo.gif';

	$uploadpath=str_replace(array('../','..\\','./','.\\'),'',$uploadpath);
	if(move_uploaded_file($_FILES['logoupload']['tmp_name'],$uploadpath)){
		$_SESSION['ADMIN_HINT']='<div style="color:green;">Upload was successful</div><br/>';
		chmod($uploadpath,0777);
	}
	else{
		$_SESSION['ADMIN_HINT']='<div style="color:red;">Saving the file failed<br/>
		Please check if you have sufficient write privileges for the folder "data/".</div>';
	}
}
function checkColor($c){
	if($c<0)$c=0;
	elseif($c>255)$c=255;
	$c=dechex($c);
	if(strlen($c)==0)$c='00';
	elseif(strlen($c)==1)$c='0'.$c;
	elseif(strlen($c)>2)$c=substr($c,0,2);
	return $c;
}
function saveBackgroundColor(){
	global $tr,$config_cache;

	$bg_title['r']=checkColor(requestVar('bg_title_r',63)); //default-blue: 82-109-139
	$bg_title['g']=checkColor(requestVar('bg_title_g',97));
	$bg_title['b']=checkColor(requestVar('bg_title_b',97));
	$config_cache['bg_title']=$bg_title['r'].$bg_title['g'].$bg_title['b'];

	$footer_text['r']=checkColor(requestVar('footer_text_r',99));
	$footer_text['g']=checkColor(requestVar('footer_text_g',99));
	$footer_text['b']=checkColor(requestVar('footer_text_b',99));
	$config_cache['footer_text_color']=$footer_text['r'].$footer_text['g'].$footer_text['b'];
	return true;
}
function saveLanguage(){
	global $config_cache;
	$lang=requestVar('language','en');
	if(!isset($lang)||!preg_match('/^[a-z]{2}$/',$lang)){
		$lang='en';
	}
	if(!file_exists('src/lang/'.$lang.'.php')){
		$lang='en';
	}
	$config_cache['language']=$lang;
	return true;
}
function saveFieldOfStudy(){
	global $tr,$config_cache;
	$config_cache['fieldofstudy']=array();

	$index=0;
	foreach(array_keys($_POST) as $postKey){
		if(substr($postKey,0,12)=='fieldofstudy'){
			if(preg_match('/^[0-9]+$/',substr($postKey,12))){
				$field=requestVar($postKey,'');
				if($field!=''){
					$config_cache['fieldofstudy'][$index]=$field;
					++$index;
				}
			}
		}
	}
	return true;
}

function saveDegrees(){
	global $tr,$config_cache;
	$config_cache['degrees']=array();
	$index=0;
	foreach(array_keys($_POST) as $postKey){
		if(substr($postKey,0,6)=='degree'){
			if(preg_match('/^[0-9]+$/',substr($postKey,6))){
				$degree=requestVar($postKey,'');
				if($degree!=''){
					$config_cache['degrees'][$index]=$degree;
					++$index;
				}
			}
		}
	}
	return true;
}
function saveEnablePublicPages(){
	global $config_cache;
	if(isset($_POST['enable_ppp'])){
		$config_cache['enable_public_profile_pages']=true;
	}
	else{
		$config_cache['enable_public_profile_pages']=false;
	}
	return true;
}
function saveEnableNotificationNewJob(){
	global $config_cache;
	if(isset($_POST['enable_notification_new_job'])){
		$config_cache['enable_email_notification_new_jobs']=true;
	}
	else{
		$config_cache['enable_email_notification_new_jobs']=false;
	}
	return true;
}

function writeConfigCacheFile(){
	global $config_cache;

	if(!isset($config_cache['bg_title']))return false;
	if(!isset($config_cache['footer_text_color']))return false;
	if(!isset($config_cache['language']))return false;
	if(!is_array($config_cache['fieldofstudy'])) return false;
	if(!is_array($config_cache['degrees'])) return false;

	$config_file='data/config.php';
	if(file_exists($config_file)){
		$data=file($config_file);
		$pipe=fopen($config_file,'w');
		$size=count($data);

		for($line=0;$line<$size;$line++){
			$content=$data[$line];
			// replace $cfg[ with $config[
			if(preg_match('/^\s*\$cfg\[/',$content)){
				preg_replace('/^\s*\$cfg\[/','$config[',$content);//$content='//deprecated: '.str_replace('//deprecated: ','',$content);
			}
		
			// remove deprecated stuff from config file	
			$deprecated=false;
			if(preg_match('/\$config\[\'language\'\]/',$content)){
				$deprecated=true;
			}
			if(preg_match('/\$config\[\'fieldofstudy\'\]/',$content)){
				$deprecated=true;
			}
			if(preg_match('/\$config\[\'degrees\'\]/',$content)){
				$deprecated=true;
			}

			if($deprecated){
				$content='//deprecated: '.str_replace('//deprecated: ','',$content);
			}
			fputs($pipe,$content);
		}

		// append new features
	}

	$fh=fopen('data/cache/config_cache.php','w');

	fputs($fh,"<?php\n");
	fputs($fh,"/*\n This file was generated automatically.\n If you change values manually, it may happen that these changes will be overwritten.\n*/\n");
	fputs($fh,"if(!defined('ALUMNISERVER'))exit;\n");

	fputs($fh,'$config_cache[\'bg_title\']=\''.$config_cache['bg_title']."';\n");
	fputs($fh,'$config_cache[\'footer_text_color\']=\''.$config_cache['footer_text_color']."';\n");
	fputs($fh,'$config_cache[\'language\']=\''.$config_cache['language']."';\n");

	foreach($config_cache['fieldofstudy'] as $key=>$value){
		fputs($fh,'$config_cache[\'fieldofstudy\']['.$key.']=\''.$value."';\n");
	}
	foreach($config_cache['degrees'] as $key=>$value){
		fputs($fh,'$config_cache[\'degrees\']['.$key.']=\''.$value."';\n");
	}

	if($config_cache['enable_public_profile_pages']==true){ $enable_pp='true';	}
	else{	$enable_pp='false';	}
	fputs($fh,'$config_cache[\'enable_public_profile_page\']='.$enable_pp.";\n");

	if($config_cache['enable_email_notification_new_jobs']==true){ $enable_notification_new_job='true';	}
	else{	$enable_notification_new_job='false';	}
	fputs($fh,'$config_cache[\'enable_email_notification_new_jobs\']='.$enable_notification_new_job.";\n");

	fputs($fh,"\n?>");
	fclose($fh);
	return true;
}

function saveConfigCache(){
	global $tr;
	// alternative: table `as_config` (
	//  `id` int(11) NOT NULL AUTO_INCREMENT,
	//  `key` varchar(50) DEFAULT NULL,
	//  `value` varchar(100) DEFAULT NULL,
	//  `lastchanged` datetime DEFAULT NULL,
	//  `changedby` varchar(12) DEFAULT NULL,
	//  PRIMARY KEY (`id`)
	//)
	// same keys result in an array

	if(isset($_POST['saveLogoUpload'])){
		saveUploadLogo();
		return;
	}
	$success=true;
	if(isset($_POST['backgroundcolor'])){
		if(!saveBackgroundColor())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else if(isset($_POST['saveLanguage'])){
		if(!saveLanguage())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else if(isset($_POST['fieldofstudy'])){
		if(!saveFieldOfStudy())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else if(isset($_POST['degrees'])){
		if(!saveDegrees())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else if(isset($_POST['public_pages'])){
		if(!saveEnablePublicPages())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else if(isset($_POST['notify_new_job'])){
		if(!saveEnableNotificationNewJob())$success=false;
		if(!writeConfigCacheFile())$success=false;
	}
	else{
		$success=false;
	}

	if($success){
		$_SESSION['ADMIN_HINT'].='<div style="color:green;">'.$tr['SavedChanges'].'</div><br/>';
	}
	else{
		$_SESSION['ADMIN_HINT'].='<div style="color:red;">'.$tr['NoChangesSaved'].'</div><br/>';
	}
}
?>