<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

if(!defined('ALUMNISERVER'))exit;
if(!isset($_SESSION['ADMIN_USER']))exit;

include('src/admin/admin_update_functions.php');

echo '<b>Installed version of the alumni software:</b><div> '.$version.'</div>

<div style="margin-top:10px;">
<b>Newest available version:</b> <div id="newestversion" style="height:40px;">trying to start a request using javascript...</div>
</div>
<script language="JavaScript" type="text/javascript">
<!--
checkVersion();
//-->
</script>

<div style="margin-top:20px;"><b>Update procedure:</b><br/>
In case there is a new version available (which could include security updates), please do the following:
<ul>
	<li>Download the newest AlumniServer software from <a href="https://sourceforge.net/projects/alumniserver/" target="_blank">https://sourceforge.net/projects/alumniserver/</a></li>
	<li>Unzip the package AlumniServerX.XX.zip inside a local folder on your computer (where X.XX is the newest available version)</li>
	<li>Log in with an FTP program to your webserver where the Alumni site is hosted. </li>
	<li>Go to the root of the Alumni website (where the "index.php" of the Alumni website is located).</li>
 	<li>Delete all files and folders, except the "data" folder.<br/>
	Instead of deleting the files, you can also move them to a folder outside of the webspace or to a folder that contains a ".htaccess" file.</li>
	<li>Copy everything from the new package to the server, except the "data" folder. </li>
	<li>Go back to this update page. In case there are modifications necessary in the database, there will be a section "Database update" below.</li>
	<li>Your data, users and settings will be kept, since they are stored in the database or in the "data" folder.</li>
</ul>
</div>';

$do_upadates=false;
if(isset($_POST['updatedb'])){
	if(requestVar('updatedb','')!='true'){
		return;
	}
	$do_upadates=true;
}

// Updating database...
$new_structure=getDbStructureFromFile('src/db_alumni.sql');
$existing_structure=getDbStructure();
// $structure[$table]['fields'][]
// $structure[$table]['extra'][]
// $structure[$table]['keys'][]

$extra_diff=getExtraDiff($new_structure,$existing_structure);
$update_statements=getUpdateQueries($extra_diff);
// $statements['add']
// $statements['change']
// $statements['create_table']

if($do_upadates){
	$num_successful_updates=0;
	$failed_updates=array();
	foreach(array_keys($update_statements) as $update_type){

		foreach($update_statements[$update_type] as $update_command){
			$r=mysql_query($update_command,$dbh);
			if($r){
				++$num_successful_updates;
			}
			else{
				$failed_updates[]=$update_command;
			}

		}
	}
	if($num_successful_updates>0){
		echo '<p style="margin-top:20px;"><b style="color:green;">Performed '.$num_successful_updates.' successful queries</b></p>';
	}
	if(count($failed_updates)>0){
		echo '<p style="margin-top:20px;"><b style="color:red;">'.count($failed_updates).' queries failed</b></p>';
		foreach($failed_updates as $command){
			echo $command.'<br/>';
		}
	}
}
else{
	if(count($update_statements)>0){
		echo '<p style="margin-top:20px;"><b>Database update</b><br/>

		<div id="dbCompare" style="margin-top:8px;">
		<a href="javascript:void(0);" onclick="loadIntoDiv(\'dbCompare\',\'src/a/admin_compare_db.php\',\'\')">
		Compare db structure</a></div>

		<div id="db_update_queries" style="margin-top:8px;">
		<a href="javascript:void(0);" onclick="loadIntoDiv(\'db_update_queries\',\'src/a/admin_update_db_queries.php\',\'\')">
		Show suggested update queries</a></div>

		<form action="AdminUpdate.php" enctype="multipart/form-data" method="post" style="margin-top:8px;">
		<input type="hidden" name="updatedb" value="true">
		<input type="submit" value="Perform database updates now" class="btn" style="margin:5px 0px;"><br/>
		</form>';
	}
}
?>