<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

if(!defined('ALUMNISERVER')) exit;
include('data/config.php');
if(file_exists('data/cache/config_cache.php'))include('data/cache/config_cache.php');

// in case old $cfg variable exists
if(!isset($config)&&isset($cfg)){
	$config=$cfg;
}
if(!isset($config_cache)&&isset($cfgdb)){
	$config_cache=$cfgdb;
}
// language
if(!isset($config_cache['language'])){
	// in case that deprecated values from config.php exist
	if(isset($config['language'])){
		$config_cache['language']=$config['language'];
	}
	else{
		$config_cache['language']='en';
	}
}
if(!preg_match('/^[a-z]{2}$/',$config_cache['language'])){$config_cache['language']='en';}
if(!file_exists('src/lang/'.$config_cache['language'].'.php')){$config_cache['language']='en';}

// field of study
if(!isset($config_cache['fieldofstudy'])){
	// in case that deprecated values from config.php exist
	if(isset($config['fieldofstudy'])){
		$config_cache['fieldofstudy']=$config['fieldofstudy'];
	}
	else if(isset($config['fieldOfStudy'])){
		$config_cache['fieldofstudy']=$config['fieldOfStudy'];
	}
	else{
		$config_cache['fieldofstudy']=array("Structural Engineering","Environmental Engineering");
	}
}

// degrees
if(!isset($config_cache['degrees'])){
	if(isset($config['degrees'])){
		$config_cache['degrees']=$config['degrees'];
	}
	else{
		$config_cache['degrees']=array("B.S.","M.Eng.");
	}
}

// colors
if(!isset($config_cache['bg_title'])||strlen($config_cache['bg_title'])!=6){$config_cache['bg_title']='61797e';}
if(!isset($config_cache['footer_text_color'])||strlen($config_cache['footer_text_color'])!=6){$config_cache['footer_text_color']='c6cccd';}

// default settings
if(!isset($config_cache['enable_public_profile_pages'])){
	$config_cache['enable_public_profile_pages']=true;
}
if(!isset($config_cache['enable_email_notification_new_jobs'])){
	$config_cache['enable_email_notification_new_jobs']=true;
}

include('src/request.php');
include('src/lang/'.$config_cache['language'].'.php');

?>
