<?php
/**************************************************************************************************
* Copyright(c) 2009 Fabian Gerold, http://www.alumniserver.net
*
* This script is part of the AlumniServer project. It is free software; you can redistribute it
* and/or modify it under the terms of the GNU General Public License as published by the Free
* Software Foundation; either version 3 of the License, or (at your option) any later version.
*
* The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html.
* A copy is found in the textfile GPL.txt
*
* This script is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************************************************/

if(!defined('ALUMNISERVER')) exit;

function unsetglobals(){
	$not_unset=array('GLOBALS'=>true,'_GET'=>true,'_POST'=>true,'_COOKIE'=>true,'_REQUEST'=>true,'_SERVER'=>true,'_SESSION'=>true,'_ENV'=>true,'_FILES'=>true);
	if(!isset($_SESSION)||!is_array($_SESSION)){$_SESSION=array();}
	$input=array_merge(array_keys($_GET),array_keys($_POST),array_keys($_COOKIE),array_keys($_SERVER),array_keys($_SESSION),array_keys($_ENV),array_keys($_FILES));

	foreach($input as $varname){
		if(isset($not_unset[$varname])){
			exit;
		}
		unset($GLOBALS[$varname]);
	}
	unset($input);
}


if(version_compare(PHP_VERSION, '6.0.0-dev', '>=')){
	define('STRIP', false);
}
else{
	@set_magic_quotes_runtime(0);
	if(@ini_get('register_globals')=='1'||strtolower(@ini_get('register_globals'))=='on'||!function_exists('ini_get')){
		unsetglobals();
	}
	define('STRIP', (get_magic_quotes_gpc()) ? true : false);
}

function requestVar($var_name,$default,$multibyte=false){
	if(!isset($_REQUEST[$var_name])||is_array($_REQUEST[$var_name])){
		return $default;
	}

	$var=$_REQUEST[$var_name];
	$type=gettype($default);
	settype($var, $type);

	if($type=='string'){
		$var=trim(htmlspecialchars(str_replace(array("\r\n", "\r", "\0"), array("\n", "\n", ''), $var), ENT_COMPAT, 'UTF-8'));
		if(!empty($var)){
			// Make sure multibyte characters are wellformed
			if($multibyte){
				if(!preg_match('/^./u', $var)){
					$var='';
				}
			}
			else{
				// no multibyte, allow only ASCII (0-127)
				$var=preg_replace('/[\x80-\xFF]/', '?', $var);
			}
		}
		$var=(STRIP) ? stripslashes($var) : $var;
	}
	return $var;
}
?>
